unit WortEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus;

type
  TBegriffEditor = class(TForm)
    LabelD: TLabel;
    Wortschatz: TMemo;
    DateiLesen: TOpenDialog;
    DateiSpeichern: TSaveDialog;
    MainMenuE: TMainMenu;
    Datei: TMenuItem;
    Speichern: TMenuItem;
    Loeschen: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LoeschenClick(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Liste:TListBox;
  public
    { Public-Deklarationen }
  end;

var
  BegriffEditor: TBegriffEditor;

implementation

{$R *.dfm}

 procedure TBegriffEditor.LoeschenClick(Sender: TObject);
  begin
   if MessageDlg('Willst du wirklich alles lschen?!',mtConfirmation,
                 [mbYes,mbNo],0)=mrNo then exit;
   Wortschatz.Clear;
   LabelD.Caption:='Noname.txt';
  end;

 procedure TBegriffEditor.FormCreate(Sender: TObject);
  begin
   Liste:=TListBox.Create(Self);
   Liste.Parent:=Self;
   Liste.Sorted:=True;
   Liste.Visible:=False;
  end;

 procedure TBegriffEditor.FormDestroy(Sender: TObject);
  begin
   Liste.Destroy;
  end;

procedure TBegriffEditor.LadenClick(Sender: TObject);
  begin
   with DateiLesen do
    begin
     Filter:='Wortdateien (*.txt) |*.txt';
     DefaultExt:='txt';
     if Execute then
      begin
       Wortschatz.Lines.LoadFromFile(Filename);
       LabelD.Caption:=ExtractFilename(FileName)+' '+
                       IntToStr(Wortschatz.Lines.Count)+' Begriffe';
      end
    end
  end;

 procedure TBegriffEditor.SpeichernClick(Sender: TObject);
  var Wo,K:Word;
      Name:String;
  begin
   if Wortschatz.Lines.Count=0 then
    begin
     MessageDlg('Es gibt NICHTS zu speichern!!',mtError,[mbOk],0);
     exit;
    end;
   for K:=0 to Wortschatz.Lines.Count-1 do
    Wortschatz.Lines[K]:=AnsiUpperCase(Wortschatz.Lines[K]); // alles gro
   for K:=0 to Wortschatz.Lines.Count-1 do
    begin
     Name:=Wortschatz.Lines[K];
     while pos(' ',Name)>0 do Delete(Name,pos(' ',Name),1); // alle Leerzeichen lschen
     Wortschatz.Lines[K]:=Name;
    end;
   Wo:=Pos(' ',LabelD.Caption);
   if Wo>0 then Name:=Copy(LabelD.Caption,1,Wo-1)
   else Name:=LabelD.Caption;
   LabelD.Caption:=Name+' '+IntToStr(Wortschatz.Lines.Count)+' Begriffe';
   Liste.Items:=Wortschatz.Lines; // in der ListBox wird sortiert
   Wortschatz.Lines:=Liste.Items;
   with DateiSpeichern do
    begin
     Filter:='Wortdateien (*.txt) |*.txt';
     DefaultExt:='txt';
     Options:=[ofOverwritePrompt];
     if Execute then
       Wortschatz.Lines.SaveToFile(Filename);
    end;
  end;

 procedure TBegriffEditor.BeendenClick(Sender: TObject);
  begin close end;

end.
